SystemOrganization addCategory: #'TyH-TP-Final'!
SystemOrganization addCategory: #'TyH-TP-Final-Test'!
SystemOrganization addCategory: #'TyH-TP-Final-Modelo'!

Object subclass: #Emisor
	instanceVariableNames: 'nombre apellido DNI CUIT direccion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!Emisor class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 21:58'!
crear: unDNI nombre: unNombre apellido: unApellido cuit: unCUIT direccion: unaDireccion

| instancia |

instancia := Emisor new.

instancia setDNI: unDNI.
instancia setNombre: unNombre.
instancia setApellido: unApellido.
instancia setCUIT: unCUIT.
instancia setDireccion: unaDireccion.

^ instancia.


	! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:50'!
getApellido
	^apellido 

! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getCUIT
	^CUIT! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getDNI
	^DNI! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getDireccion
	^direccion ! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:52'!
getNombre
	^nombre ! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:54'!
setApellido: unApellido

	apellido := unApellido.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:54'!
setCUIT: unCUIT

	CUIT := unCUIT.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setDNI: unDNI

	DNI :=DNI.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setDireccion: unaDireccion

	direccion := unaDireccion.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setNombre: unNombre

	nombre := unNombre.! !

Object subclass: #OrdenTest
	instanceVariableNames: 'precio cantidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Test'!

!OrdenTest class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:52'!
crear: unaCantidad precio:unPrecio

| instancia |

instancia := OrdenTest new.

instancia setCantidad: unaCantidad.
instancia setPrecio: unPrecio.

^instancia.! !

!OrdenTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:50'!
getCantidadDeHijos 

^cantidad.! !

!OrdenTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:50'!
getPrecioMercado 

^precio.
! !

!OrdenTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:50'!
setCantidad: unaCantidad

cantidad := unaCantidad.! !

!OrdenTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:49'!
setPrecio: unPrecio

precio := unPrecio.! !

Object subclass: #OrderBook
	instanceVariableNames: 'ordenesCompra ordenesVenta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!OrderBook class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:21'!
crear

| instancia | 

instancia := OrderBook new.

instancia inicializar.

^instancia.
! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:22'!
agregarOrdenCompra: unaOrden

ordenesCompra add: unaOrden.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:23'!
agregarOrdenVenta: unaOrden

ordenesVenta add: unaOrden.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:22'!
incializar

ordenesCompra := OrderedCollection new.
ordenesVenta := OrderedCollection new.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:23'!
obtenerOrdenesCompraCandidatas: unPrecioMercado

! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:23'!
obtenerOrdenesVentaCandidatas: unPrecioMercado

! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:24'!
quitarOrdenCompra: unaOrden

ordenesCompra remove: unaOrden.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:24'!
quitarOrdenVenta: unaOrden

ordenesVenta remove: unaOrden.! !

Object subclass: #PEM
	instanceVariableNames: 'emisores tickets orderBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!PEM class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:02'!
crear
	"Crea una nueva instancia del PEM con las colecciones incializadas"

	| instancia |

instancia := PEM new.

! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:25'!
agrearOrdenCompra: unaOrden

orderBook agregarOrdenCompra: unaOrden.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:06'!
agregarEmisor: unEmisor

	emisores add: unEmisor.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:26'!
agregarOrdenVenta: unaOrden

orderBook agregarOrdenVenta: unaOrden.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:16'!
agregarTradingTicket: unTicket

tickets add: unTicket.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:25'!
incializar

"Inicializa las colecciones del PEM"

emisores := OrderedCollection new.
tickets := OrderedCollection new. 
orderBook := OrderBook new.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:07'!
quitarEmisor: unEmisor

emisores remove: unEmisor.! !

Object subclass: #RegistroTablaPrecioMercado
	instanceVariableNames: 'precio demanda oferta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Test'!

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getDemanda

^demanda.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getOferta

^oferta.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getPrecio

^precio.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:06'!
setDemanda: unaCantidad

demanda := unaCantidad.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:06'!
setOferta: unaCantidad

oferta := unaCantidad.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
setPrecio: unPrecio

precio := unPrecio.! !

Object subclass: #TablaPrecioMercado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Test'!

Object subclass: #TradingTicket
	instanceVariableNames: 'ordenCompra ordenVenta fechaTransaccion precioMercado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!TradingTicket class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:15'!
crear: unaOrdenCompra ordenVenta: unaOrdenVenta precioMercado: unPrecio

| instancia | 


instancia := TradingTicket new.

instancia setPrecioMercado: unPrecio.
instancia setOrdenCompra: unaOrdenCompra.
instancia setOrdenVenta: unaOrdenVenta.
instancia setFechaTransaccion: Date today.

^instancia.
! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:11'!
getFechaTransaccion

	^fechaTransaccion.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getOrdenCompra

	^ordenCompra.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getOrdenVenta

	^ordenVenta.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getPrecioMercado

	^precioMercado.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:12'!
setFechaTransaccion: unaFecha

fechaTransaccion := unaFecha.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:12'!
setOrdenCompra: unaOrdenCompra

ordenCompra := unaOrdenCompra.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:12'!
setOrdenVenta: unaOrdenVenta

ordenVenta = unaOrdenVenta.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:13'!
setPrecioMercado: unPrecio

precioMercado := unPrecio.! !
